//@author: antokhio
//@help: template for compute shaders
//@tags: CS, template
//@credits: 

StructuredBuffer<float3> Input; 
StructuredBuffer<int> Select;
AppendStructuredBuffer<float3> Output : BACKBUFFER;
ByteAddressBuffer InputCountBuffer;

[numthreads(1, 1, 1)]
void CS( uint3 tid : SV_DispatchThreadID )
{
	//Structure count at 0 address
	uint cnt = InputCountBuffer.Load(0);
	
	//Important since we mght have override
	if (tid.x >= cnt) { return; }

	if (Select[tid.x]) 
		Output.Append(Input[tid.x]);
	
}


technique11 Template
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}




